import 'dart:math';

// No const definition however random docs state this as max int.
const int maxInt = 1 << 32;

Iterable<int> randomInts() sync* {
  var gen = Random();

  while (true) {
    yield gen.nextInt(maxInt);
  }
}

Iterable<int> randomIntsInclusiveRange(int min, int max) sync* {
  if (min < 0)
    throw new ArgumentError.value(min, "min", "Must be >= 0");

  if (max < 0)
    throw new ArgumentError.value(min, "max", "Must be >= 0");

  if (max > maxInt)
    throw new ArgumentError.value(max, "max", "Must be less than $maxInt");

  if (max < min)
    throw new ArgumentError.value(max, "max", "Must be greater than or equal to min");

  var gen = Random();

  while (true) {
    yield min == max ? min : gen.nextInt((max - min) + 1) + min;
  }
}