import 'package:test/test.dart';

import 'package:perkataan/src/math_utils.dart';

void main() {
  group('Range', () {
    test('Min less than 0 throws', () {
       expect(() => randomIntsInclusiveRange(-1, 10), throwsArgumentError);
    });

    test('Max less than 0 throws', () {
       expect(() => randomIntsInclusiveRange(0, -1), throwsArgumentError);
    });

    test('Max less than min', () {
       expect(() => randomIntsInclusiveRange(5, 4), throwsArgumentError);
    });

    test('Same range', () {
       expect(randomIntsInclusiveRange(5, 5).first, 5);
    });
    
    test('inclusive within range', () {
      // flaky test but after 20 attempts will probably get both :-)
      var values = randomIntsInclusiveRange(5, 6).take(20).toSet();
      expect(values, containsAll(<int>[5, 6]));
    });

    test('generate', () {
      int min = 2;
      int max = 10;
      expect(randomIntsInclusiveRange(min, max).first, inInclusiveRange(min, max));
    });
  });

  group('Generate ints', () {
    test('generate', () {
      expect(randomInts().first, isNotNull);
    });
  });
}