import 'package:test/test.dart';

import 'package:perkataan/src/words.dart';

void main() {
  Words words;

  setUp(() {
    words = Words.all();
  });

  group('Default - ', () {
    group('size - ', () {
      test('Load all words', () {
        expect(words.numOfWords(), 84095);
      });

      test('Load all words of size 1', () {
        expect(words.size(1), 26);
      });

      test('Load all words of size 2', () {
        expect(words.size(2), 174);
      });

      test('Load all words of size 3', () {
        expect(words.size(3), 872);
      });

      test('Load all words of size 4', () {
        expect(words.size(4), 2980);
      });

      test('Load all words of size 5', () {
        expect(words.size(5), 5794);
      });

      test('Load all words of size 6', () {
        expect(words.size(6), 9168);
      });

      test('Load all words of size 7', () {
        expect(words.size(7), 12467);
      });

      test('Load all words of size 8', () {
        expect(words.size(8), 13311);
      });

      test('Load all words of size 9', () {
        expect(words.size(9), 12211);
      });

      test('Load all words of size 10', () {
        expect(words.size(10), 10041);
      });

      test('Load all words of size 11', () {
        expect(words.size(11), 7129);
      });

      test('Load all words of size 12', () {
        expect(words.size(12), 4617);
      });

      test('Load all words of size 13', () {
        expect(words.size(13), 2747);
      });

      test('Load all words of size 14', () {
        expect(words.size(14), 1368);
      });

      test('Load all words of size 15', () {
        expect(words.size(15), 678);
      });

      test('Load all words of size 16', () {
        expect(words.size(16), 299);
      });

      test('Load all words of size 17', () {
        expect(words.size(17), 149);
      });

      test('Load all words of size 18', () {
        expect(words.size(18), 40);
      });

      test('Load all words of size 19', () {
        expect(words.size(19), 15);
      });

      test('Load all words of size 20', () {
        expect(words.size(20), 8);
      });

      test('Load all words of size 21', () {
        expect(words.size(21), 1);
      });

      test('Load all words of size 22', () {
        expect(words.size(22), 0);
      });
    });  
  });

  group('utilities', () {
    test('wordAnagram', () {
      var res = words.anagrams('rode').toList(growable: false);

      expect(res.length, 4);
      expect(res, containsAll(['doer', 'oder', 'redo', 'rode']));
    });

    test('crossword', () {
      var letters = 'isu';
      var res = words.wordsMatching(8, {1:letters.codeUnitAt(0), 4:letters.codeUnitAt(1), 6:letters.codeUnitAt(2)}).toList(growable: false);

      expect(res.length, 2);
      expect(res[0], 'dinosaur');
      expect(res[1], 'hibiscus');
    });

    test('random words - single range', () {
      int expectedSize = 9;
      expect(words.randomWords(expectedSize, expectedSize).first.length,  expectedSize);
    });

    try {
      test('random words - range', () {
        int min = 5;
        int max = 6;
        // Use a sufficient size of generated values (42) to ensure we are within the given range.
        var lengths = words.randomWords(min, max).take(42).map((w) => w.length).toList(growable: false);
        // Is there an iterable inclusive test?
        for (var length in lengths) {
          expect(length,  inInclusiveRange(min, max));
        }
      });
    } catch (e, s) {
      print(s);
    }

    test('subanagrams', () {
      var res = words.subAnagrams(4,  "print").toList(growable: false);

      expect(res.length, 3);
      expect(res, containsAll(['pint', 'trip', 'print']));
    });
  });
  
  group('On Demand', () {
    test('Load from List', () {
      expect(Words.from(['one', 'two', 'three']).numOfWords(), 3);
    });
  });
}
